<?php
declare(strict_types=1);

namespace CatequilTest\ORM;

use Catequil\ORM\ConfigProvider;
use Laminas\ConfigAggregator\ArrayProvider;
use Laminas\ConfigAggregator\ConfigAggregator;
use Laminas\ConfigAggregator\PhpFileProvider;
use Laminas\ServiceManager\ServiceManager;
use PHPUnit\Framework\TestCase;
use Psr\Container\ContainerInterface;

/**
 * Class AbstractTestCase
 *
 * @package CatequilTest\ORM
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-orm
 */
abstract class AbstractTestCase extends TestCase
{
    protected static array $config = [];

    protected static function getContainer(array $config = []): ContainerInterface
    {
        $config = (new ConfigAggregator([
            \Catequil\Db\ConfigProvider::class,
            ConfigProvider::class,
            new PhpFileProvider(__DIR__ . '/local.php'),
            new ArrayProvider(static::$config),
            new ArrayProvider($config),
        ]))->getMergedConfig();

        $config['dependencies']['services']['config'] = $config;
        return new ServiceManager($config['dependencies']);
    }
}